#pragma once
#include "ColSegment.h"
//QƃNX
class CGameMain;
class CFmfMap;

//⓹C̍őlBi0͕`pA1͎lp`̓蔻pBj
const int MaxLayerNum = 0;

class CCollision {
	CGameMain* Game;
	float OffsetL, OffsetR, OffsetU, OffsetD;
	POINT mPt[8];
	int ColType;
public:
	CCollision(POINT pt[], float offset_l, float offset_u, float offset_r, float offset_d, int col_type, CGameMain* game);
	//蔻̃`FbN
	POINT CheckMap(int x, int y);
	//C[ԍmFBi⓹pj
	int GetChipLayerNum(int x, int y);
	//⓹̓蔻
	Vector2 CheckSlope(float x, float y,Segment& Slope,int layernum,int slopecond);
	//vC[̐̃Zbg
	Segment SetSegment(int x, int y, int slopecond);
	//⓹̐̃Zbg(cond͏o͗pB)
	Segment SetSlopeSeg(int x, int y, int layer, int* cond = 0);
	//⓹̃ubNƂĂ̓蔻B
	POINT CheckSlopeBlock(int x, int myy, int layernum);
	//ubN̍̓_Bi⓹pj
	Vector2 GetMatrixPos(float myx, float myy);
	//̏Փ˔
	void GetXPosition(float* myx, float* myy);
	//c̏Փ˔
	void GetYPosition(float* myx, float* myy,int* jcount, bool* gflag);
	//⓹̏Փ˔
	void GetSlope(float* myx, float* myy, int* jcount, bool* gflag);
	void SlopeCollision(float* myx, float* myy, int* jcount, bool* gflag);
	void GetMove(float* myx, float* myy,int* jcount,bool* gflag);
	int GetColType() { return ColType; }
};
const float GRAVMAX = 20.0F;
const float GRAV = 0.5F;

const int TypeSLOPE = 1;
const int TypeBLOCK = 0;